Index: demo/coloring.cc
===================================================================
--- demo/coloring.cc	(revision 1577)
+++ demo/coloring.cc	(revision 1636)
@@ -1,2 +1,18 @@
+/* -*- C++ -*-
+ * demo/coloring.cc - Part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
 #include <vector>
 
Index: demo/descriptor_map_demo.cc
===================================================================
--- demo/descriptor_map_demo.cc	(revision 1556)
+++ demo/descriptor_map_demo.cc	(revision 1636)
@@ -1,4 +1,5 @@
 /* -*- C++ -*-
- * demo/descriptor_map_demo.cc - Part of LEMON, a generic C++ optimization library
+ * demo/descriptor_map_demo.cc - Part of LEMON, a generic C++ optimization
+ * library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
Index: demo/dijkstra_demo.cc
===================================================================
--- demo/dijkstra_demo.cc	(revision 1583)
+++ demo/dijkstra_demo.cc	(revision 1636)
@@ -1,4 +1,4 @@
 /* -*- C++ -*-
- * demo/lp_maxflow_demo.cc - Part of LEMON, a generic C++ optimization library
+ * demo/dijkstra_demo.cc - Part of LEMON, a generic C++ optimization library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
Index: demo/dim_to_dot.cc
===================================================================
--- demo/dim_to_dot.cc	(revision 1577)
+++ demo/dim_to_dot.cc	(revision 1636)
@@ -1,3 +1,17 @@
-// -*- c++ -*-
+/* -*- C++ -*-
+ * demo/dim_to_dot.cc - Part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
 
 // Use a DIMACS max flow file as stdin.
Index: demo/hello_lemon.cc
===================================================================
--- demo/hello_lemon.cc	(revision 1583)
+++ demo/hello_lemon.cc	(revision 1636)
@@ -1,4 +1,4 @@
 /* -*- C++ -*-
- * demo/lp_maxflow_demo.cc - Part of LEMON, a generic C++ optimization library
+ * demo/hello_lemon.cc - Part of LEMON, a generic C++ optimization library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
Index: demo/lp_demo.cc
===================================================================
--- demo/lp_demo.cc	(revision 1610)
+++ demo/lp_demo.cc	(revision 1636)
@@ -1,4 +1,4 @@
 /* -*- C++ -*-
- * demo/graph_to_eps.cc - Part of LEMON, a generic C++ optimization library
+ * demo/lp_demo.cc - Part of LEMON, a generic C++ optimization library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
Index: demo/min_route.cc
===================================================================
--- demo/min_route.cc	(revision 1435)
+++ demo/min_route.cc	(revision 1636)
@@ -1,2 +1,18 @@
+/* -*- C++ -*-
+ * demo/min_route.cc - Part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
 #include <iostream>
 #include <fstream>
Index: demo/reader_writer_demo.cc
===================================================================
--- demo/reader_writer_demo.cc	(revision 1583)
+++ demo/reader_writer_demo.cc	(revision 1636)
@@ -1,4 +1,5 @@
 /* -*- C++ -*-
- * demo/lp_maxflow_demo.cc - Part of LEMON, a generic C++ optimization library
+ * demo/reader_writer_demo.cc - Part of LEMON, a generic C++ optimization
+ * library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
Index: demo/sub_graph_adaptor_demo.cc
===================================================================
--- demo/sub_graph_adaptor_demo.cc	(revision 1583)
+++ demo/sub_graph_adaptor_demo.cc	(revision 1636)
@@ -1,4 +1,5 @@
 /* -*- C++ -*-
- * demo/lp_maxflow_demo.cc - Part of LEMON, a generic C++ optimization library
+ * demo/sub_graph_adaptor_demo.cc - Part of LEMON, a generic C++ optimization
+ * library
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport